//---------------------------------------------------------------------------

#ifndef UCadenaExtH
#define UCadenaExtH

#include "limits.h"
#include <iostream>
using namespace std;
//---------------------------------------------------------------------------

typedef unsigned char CharExt;
typedef unsigned int tSize;

const tSize LonChEx = (CHAR_MAX+1)*2; // 256=128*2 , del 0 al 255

struct CadenaExt
{
        tSize cont;
        tSize maxLC;
        CharExt* vector;
};

void init(CadenaExt& Cad, tSize S=320);
void free(CadenaExt& Cad);
void clear(CadenaExt& Cad);
void assign(CadenaExt& CadIzq, const CadenaExt& CadDer);
void resize(CadenaExt& Cad, tSize S);
inline tSize size(const CadenaExt& Cad) {return Cad.cont;};
inline tSize max_size(const CadenaExt& Cad) {return Cad.maxLC;};
inline bool inrange(const CadenaExt& Cad, tSize N) {return (N < size(Cad));};
bool push_back(CadenaExt& Cad, CharExt C);
bool pop_back(CadenaExt& Cad);
CharExt at(const CadenaExt& Cad, tSize N);
CharExt& at(CadenaExt& Cad, tSize N);
bool replace(CadenaExt& Cad, tSize N, const CharExt C);
bool swap(CadenaExt& Cad, tSize N, tSize K);
void toCadenaExt(const char cstr[], CadenaExt& Cad);
bool getLine(CadenaExt& Cad, istream& Ent);
bool put(const CadenaExt& Cad, ostream& Sal);
inline bool putLine(const CadenaExt& Cad, ostream& Sal) {put(Cad, Sal); Sal << endl; return Sal;};

#endif
