//---------------------------------------------------------------------------

#ifndef UForPract2H
#define UForPract2H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>

#include <UCifraRC4.h>
#include <fstream>
//---------------------------------------------------------------------------
class TForPrac1 : public TForm
{
__published:	// IDE-managed Components
        TMemo *MemOrig;
        TMemo *MemCifr;
        TEdit *EdiArch;
        TButton *BotCifrar;
        TButton *BotDescifrar;
        TButton *BotSalir;
        TLabel *LabClave;
        TOpenDialog *OpenDialog1;
        TSaveDialog *SaveDialog1;
        TMainMenu *MainMenu1;
        TLabel *LabArchivo;
        TLabel *LabOriginal;
        TLabel *LabCifrado;
        TMenuItem *Archivo1;
        TMenuItem *RC41;
        TMenuItem *Cifrar1;
        TMenuItem *Descifrar1;
        TMenuItem *Nuevo1;
        TMenuItem *Abrir1;
        TMenuItem *GuardarTexto1;
        TMenuItem *N1;
        TMenuItem *Salir1;
        TMenuItem *Texto1;
        TMenuItem *Cifrado1;
        TLabel *LabPass;
        TMenuItem *Guardar1;
        void __fastcall BotSalirClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall Texto1Click(TObject *Sender);
        void __fastcall Cifrado1Click(TObject *Sender);
        void __fastcall GuardarTexto1Click(TObject *Sender);
        void __fastcall Nuevo1Click(TObject *Sender);
        void __fastcall BotCifrarClick(TObject *Sender);
        void __fastcall BotDescifrarClick(TObject *Sender);
        void __fastcall MemOrigChange(TObject *Sender);
        void __fastcall Guardar1Click(TObject *Sender);
private:	// User declarations
        AnsiString NombArchOri, NombArchCif;
        CifraRC4 cifrado;
        bool modificado;
        CadenaExt clave;
		bool cfrStream(ifstream *strEnt, ofstream *strSal);
public:		// User declarations
        __fastcall TForPrac1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForPrac1 *ForPrac1;
//---------------------------------------------------------------------------
#endif
