//---------------------------------------------------------------------------

#ifndef UCifraRC4H
#define UCifraRC4H

#include <UCadenaExt.h>
//---------------------------------------------------------------------------

typedef CharExt (*FunCfr)(CharExt, CharExt);
enum opeCfr {cifrar, descifrar};

const tSize LonCtrl = 32; // char de control: del 0 al 31
const tSize LonAlfa = LonChEx - LonCtrl; // 256 32=224, del 0 al 223

struct CifraRC4
{
        tSize cA, cB;
        CadenaExt abc;
        CadenaExt clave;
        FunCfr funCfr;
};

bool init(CifraRC4& RC);
void free(CifraRC4& RC);
bool setClave(CifraRC4& RC, const CadenaExt& clave); // semilla
void setOperCfr(CifraRC4& RC, opeCfr op);
void exeOperCfr(CifraRC4& RC, const CadenaExt& Ent, CadenaExt& Sal);

#endif
